  DECLARE SUB Viewgif (File$, MyOffX%, MyOffY%, Transparent%)
  DECLARE SUB WriteReg (reg%, Value%)
  DECLARE SUB MousePut ()
mouse.setup:
  DECLARE FUNCTION MouseInterr% (num%, ax%, bx%, cx%, dx%)
  DECLARE SUB MousePointer (OnOrOff$)
  DECLARE SUB MouseSpeed (Speed%)
  DECLARE SUB MouseSet (x%, y%)
  DECLARE SUB MouseArea (x1%, x2%, y1%, y2%)
  DECLARE SUB LoadConfiguration ()
  DECLARE SUB MouseDriver (ax%, bx%, cx%, dx%)
  DECLARE FUNCTION MouseInit% ()
  DECLARE SUB mouseshow ()
  DECLARE SUB mousestatus (lb%, RB%, Xmouse%, Ymouse%)
  DECLARE SUB MouseWait ()

   '---------------------------------------------------------------
   'START OF ROUTINE TO CHANGE THE DIRECTORY TO WHERE THE FILES ARE
'when running for the 1st time put the proper path in when asked, or you will
'need to run it again.

'PUT IN THE FOLDER NAME !!!!!!!!
 foldername$ = "qbchess1"   'put folder name in the quotations to make it work
                            'eg. "qbasic"
 CLS
 ON ERROR GOTO make.curdir.dat.file

 SHELL "cd\"
 OPEN foldername$ + ".dat" FOR INPUT AS #1
 LINE INPUT #1, name$
 CLOSE #1
 CHDIR name$
 ON ERROR GOTO delete.dat.file
 GOTO curdir.set

delete.dat.file:
 SHELL "cd\"
 KILL foldername$ + ".dat"

make.curdir.dat.file:
 SCREEN 0
 CLS
 LOCATE 16, 27: COLOR 7, 1: PRINT " Change Install Directory "
 LOCATE 18, 29: PRINT " Do not end with a  \ "
 LOCATE 9, 36 + LEN(name$): COLOR 15, 0: PRINT ""
 LOCATE 9, 23: COLOR 0, 7: PRINT " Install To"
    
        DO
         valid$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ:\!?1234567890$-_"
         k$ = UCASE$(INKEY$)
         IF LEN(k$) THEN
         tl = LEN(name$)
         IF INSTR(valid$, k$) THEN
            IF tl < 43 THEN name$ = name$ + k$
          ELSEIF k$ = CHR$(8) THEN
            IF tl THEN name$ = LEFT$(name$, tl - 1)
         END IF
         LOCATE 9, 36: COLOR 7, 0: PRINT name$
         LOCATE 9, 36 + LEN(name$): COLOR 15, 0: PRINT ""
         LOCATE 9, 37 + LEN(name$): COLOR 7, 0: PRINT " "
         END IF
        LOOP UNTIL k$ = CHR$(13) AND RIGHT$(name$, 1) <> "\"
    
        DO
         foldernamefrompath$ = RIGHT$(name$, 2 + aa)
         aa = aa + 1
        LOOP UNTIL LEFT$(foldernamefrompath$, 1) = "\"

 foldernamefrompath$ = RIGHT$(name$, aa)

 IF foldernamefrompath$ <> UCASE$(foldername$) THEN
  LOCATE 5, 1
  PRINT "Either the Folder Name in the path or the foldername$ is incorrect!"
  PRINT "They do not match - Please make the correction and run again!"
  END
 END IF

 OPEN MID$(name$, 1, 2) + "\" + foldername$ + ".dat" FOR OUTPUT AS #1
 PRINT #1, name$
 CLOSE #1

 SHELL "cd\"
 OPEN foldername$ + ".dat" FOR INPUT AS #1
 LINE INPUT #1, name$
 CLOSE #1
 CHDIR name$

curdir.set:
   'END OF ROUTINE TO CHANGE THE DIRECTORY TO WHERE THE FILES ARE
   '-------------------------------------------------------------
 
  DIM SHARED mouse$
  RESTORE
  player$ = "1"
  mouse$ = SPACE$(57)
  FOR I% = 1 TO 57
    READ a$
    h$ = CHR$(VAL("&H" + a$))
    MID$(mouse$, I%, 1) = h$
  NEXT I%
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00
  LoadConfiguration

  MS% = MouseInit%
  IF NOT MS% THEN
    PRINT "Mouse not found": LET AMOUSE$ = "NO":
  END IF
  PRINT "Mouse found and initialized": LET AMOUSE$ = "YES"
  mouseshow

vardef:
'screen setup
  SCREEN 13
 
'qb chess title page
  Viewgif "chess", 0, 0, -1
  Viewgif "qbchess", 70, 30, 52
  SLEEP 1
  CLS
 
'constant definitions
  CONST true = 1, false = 0
  CONST highlight = 4
  CONST BLUE = 65536, GREEN = 256, RED = 1
  CONST done.waiting = 3
'dimension statements
  DIM SHARED start(0 TO 7, 0 TO 7)
  DIM SHARED square(-7 TO 15, -7 TO 15)
  DIM SHARED inisquare(0 TO 7, 0 TO 7)
  DIM SHARED str(13) AS STRING
  DIM SHARED mover(200 * 20)
  DIM mouse%(0 TO 45)
  DIM SHARED XLength, YLength, header$, nowwait$, waitnow
  DIM SHARED points, t, m$, x, y, oldx, oldy, a, b, scl, xini, yini
'minor initial variables
  scl = 20
  bwid = 90: bxmn = 3: bxmx = bxmn + bwid: bymn = 3: bymx = 196
  tox = (320 - bwid - (scl * 8)) / 2 + bwid + 5
  GOSUB pal.set

Setup:
  OPEN "chessdat.dat" FOR INPUT AS #2
  FOR g = 2 TO 13: INPUT #2, str(g): NEXT
  FOR b = 0 TO 7: FOR a = 0 TO 7
    INPUT #2, start(a, b)
  NEXT: NEXT
  FOR b = 0 TO 7: FOR a = 0 TO 7
    INPUT #2, square(a, b), inisquare(a, b)
  NEXT: NEXT
  CLOSE

restart: CLS : MousePointer "Off": header$ = "                         "
  FOR b = 0 TO 7: FOR a = 0 TO 7: square(a, b) = inisquare(a, b): NEXT: NEXT
  xini = (320 - (scl * 8)) / 2: yini = (200 - (scl * 8)) / 2
  GOSUB board.draw
  WHILE POINT(tox, 100) <> 0
    FOR m = 295 TO 16 STEP -20
      GET (m, 1)-(m + 19, 199), mover
      PUT (m + 1, 1), mover, PSET
    NEXT
  WEND: xini = tox + 1
  GOSUB boxes
  MousePointer "On": castle(1) = 0: castle(2) = 0

Main: MousePointer "On"
  DO
    GOSUB prt.stats
    RESTORE
    GOSUB get.key
    GOSUB mov.key
  LOOP

prt.stats:
  k1 = 0: k2 = 0: k4 = 0: k5 = 0: k6 = 0
  FOR k = 0 TO 7: FOR l = 0 TO 7
  IF square(l, k) = 10 AND player$ = "2" THEN k2 = 1: k3 = 0: GOSUB check: IF w1 = 0 GOTO stats
  IF square(l, k) = 11 AND player$ = "1" THEN k1 = 1: k3 = 0: GOSUB check: IF w1 = 0 GOTO stats
  IF square(l, k) = 10 AND player$ = "1" THEN k2 = 1: k3 = 1: GOSUB check
  IF square(l, k) = 11 AND player$ = "2" THEN k1 = 1: k3 = 1: GOSUB check
  NEXT: NEXT
  IF k6 = 1 THEN COLOR 64: LOCATE 24, 5: PRINT "Check"; : IF player$ = "1" THEN k$ = "1" ELSE k$ = "2"
stats:
  COLOR 172: LOCATE 2, 2: PRINT "Left click": LOCATE , 2: PRINT " to choose"
  PRINT : LOCATE , 2: PRINT "Right click": LOCATE , 2: PRINT " to place"
  IF player$ = "1" THEN COLOR 7 ELSE COLOR 4
  PRINT : LOCATE , 5: IF piece <= 1 THEN PRINT "       " ELSE PRINT pname$
  COLOR 98: PRINT : LOCATE , 2: PRINT " Player  "; : IF player$ = "1" THEN COLOR 7 ELSE COLOR 4
  PRINT player$
  COLOR 98: LOCATE 16, 8: PRINT "QB"
  LOCATE 22, 3: PRINT "Chess"
  LOCATE 1, 20: PRINT "By Craig Parmer"
  LOCATE 24, 19: PRINT "Hit Esc to give up";
RETURN

get.key:
  WHILE INKEY$ <> "" OR m$ <> "" OR MouseB% <> 0: m$ = "": MouseB% = 0: MouseWait
    IF PL$ = "Y" OR PL$ = "y" THEN RUN
    IF PL$ = "N" OR PL$ = "n" THEN SYSTEM
  WEND
  oldx = x: oldy = y: a = oldx: b = oldy
  WHILE m$ = "" AND MouseB% = 0
    DO: MouseWait
      IF PL$ = "Y" OR PL$ = "y" THEN RUN
      IF PL$ = "N" OR PL$ = "n" THEN SYSTEM
      GOSUB prt.headings
    LOOP WHILE MouseB% = 0 AND m$ = "": a = x: b = y
DATA.Mouse:
DATA 55,8b,ec,56,57,8b,76,0c,8b,04,8b,76,0a,8b,1c,8b,76,08,8b,0c,8b,76,06,8b
DATA 14,cd,21,8b,76,0c,89,04,8b,76,0a,89,1c,8b,76,08,89,0c,8b,76,06,89,14,5f
DATA 5e,5d,ca,08,00
    
IF (MouseX% \ 2 - xini) \ 20 >= 0 AND (MouseX% \ 2 - xini) \ 20 <= 7 AND (MouseY% - yini) \ 20 >= 0 AND (MouseY% - yini) \ 20 <= 7 THEN
  x = (MouseX% \ 2 - xini) \ 20: y = (MouseY% - yini) \ 20
  IF square(oldx, oldy) \ 2 = square(oldx, oldy) / 2 THEN oldplayerno = 2 ELSE oldplayerno = 1
  IF square(x, y) \ 2 = square(x, y) / 2 THEN playerno = 2 ELSE playerno = 1
  IF square(oldx, oldy) <= 1 THEN oldplayerno = 0
  IF square(x, y) <= 1 THEN playerno = 0
  IF MouseB% = 2 AND playerno <> oldplayerno THEN
    sq = square(x, y): ReX = x: ReY = y
    oldsq = square(oldx, oldy)
      SELECT CASE square(oldx, oldy)
        CASE 2: 'checks 2player pawn move legitimacy
          IF sq > 1 AND sq \ 2 <> sq / 2 AND y = oldy + 1 AND ABS(x - oldx) = 1 THEN
            IF y = 7 THEN piece = 12: square(x, y) = piece: a = x: b = y
            RETURN
          END IF
          IF y = 5 AND (x = oldx - 1 OR x = oldx + 1) AND square(x, y - 1) = 3 THEN
            IF square(x, y) = 0 THEN square(x, y - 1) = 1 ELSE square(x, y - 1) = 0
            square(x, y) = 3
            RETURN
          END IF
          SELECT CASE oldy
            CASE 1: IF NOT ((y = oldy + 2 OR y = oldy + 1) AND x = oldx) THEN x = oldx: y = oldy: buzz = true
            CASE 0, 2, 3, 4, 5, 6, 7: IF NOT (y = oldy + 1 AND x = oldx) THEN x = oldx: y = oldy: buzz = true
          END SELECT
          IF y <> oldy THEN
            FOR chk.y = oldy TO y STEP (ABS(y - oldy) / (y - oldy))
            IF square(x, chk.y) > 1 AND square(x, chk.y) <> square(oldx, oldy) THEN y = oldy: x = oldx: buzz = true
            NEXT
          END IF
          IF y = 7 THEN piece = 12: square(x, y) = piece: a = x: b = y
        CASE 3: 'checks 1player pawn move legitimacy
          IF sq > 1 AND sq \ 2 = sq / 2 AND y = oldy - 1 AND ABS(x - oldx) = 1 THEN
            IF y = 0 THEN piece = 13: square(x, y) = piece: a = x: b = y
            RETURN
          END IF
          IF y = 2 AND (x = oldx - 1 OR x = oldx + 1) AND square(x, y + 1) = 2 THEN
            IF square(x, y) = 0 THEN square(x, y + 1) = 1 ELSE square(x, y + 1) = 0
            square(x, y) = 3
            RETURN
          END IF
          SELECT CASE oldy
            CASE 6: IF NOT ((y = oldy - 2 OR y = oldy - 1) AND x = oldx) THEN x = oldx: y = oldy: buzz = true
            CASE 0, 1, 2, 3, 4, 5, 7: IF NOT (y = oldy - 1 AND x = oldx) THEN x = oldx: y = oldy: buzz = true
          END SELECT
            IF y <> oldy THEN
              FOR chk.y = oldy TO y STEP (ABS(y - oldy) / (y - oldy))
              IF square(x, chk.y) > 1 AND square(x, chk.y) <> square(oldx, oldy) THEN y = oldy: x = oldx: buzz = true
              NEXT
            END IF
            IF y = 0 THEN piece = 13: square(x, y) = piece: a = x: b = y
        CASE 4, 5: 'checks knight move legitimacy
          IF NOT ((ABS(x - oldx) = 2 AND ABS(y - oldy) = 1) OR (ABS(x - oldx) = 1 AND ABS(y - oldy) = 2)) THEN x = oldx: y = oldy: buzz = true
        CASE 6, 7: 'checks bishop move legitimacy
          IF NOT (ABS(x - oldx) = ABS(y - oldy)) THEN x = oldx: y = oldy: buzz = true
          IF ReY <> oldy AND ReX <> oldx THEN
            chk.x = oldx: FOR chk.y = oldy TO ReY STEP (ABS(ReY - oldy) / (ReY - oldy))
            IF chk.y <> oldy THEN chk.x = chk.x + ((ABS(ReX - oldx) / (ReX - oldx)))
            IF square(chk.x, chk.y) > 1 AND square(chk.x, chk.y) <> square(oldx, oldy) AND (chk.x <> ReX AND chk.y <> ReY) THEN y = oldy: x = oldx: buzz = true
            NEXT
          END IF
        CASE 8, 9: 'checks rook move legitimacy
          IF NOT (x = oldx OR y = oldy) THEN x = oldx: y = oldy: buzz = true
          IF y <> oldy THEN
            FOR chk.y = oldy TO y STEP (ABS(y - oldy) / (y - oldy))
            IF square(x, chk.y) > 1 AND square(x, chk.y) <> square(oldx, oldy) AND chk.y <> y THEN y = oldy: x = oldx: buzz = true
            NEXT
          END IF
          IF x <> oldx THEN
            FOR chk.x = oldx TO x STEP (ABS(x - oldx) / (x - oldx))
            IF square(chk.x, y) > 1 AND square(chk.x, y) <> square(oldx, oldy) AND chk.x <> x THEN y = oldy: x = oldx: buzz = true
            NEXT
          END IF
        CASE 10, 11: 'checks king move legitimacy
          IF NOT (ABS(x - oldx) <= 1 AND ABS(y - oldy) <= 1) THEN x = oldx: y = oldy: buzz = true
          IF oldy = ReY AND ReX = 6 AND (square(7, ReY) = 8 OR square(7, ReY) = 9) AND square(5, ReY) < 2 AND square(ReX, ReY) < 2 THEN
            IF (player$ = "2" AND kingcastle1 = 0 AND rookcastle11 = 0) OR (player$ = "1" AND kingcastle2 = 0 AND rookcastle22 = 0) THEN
              k5 = 1: k4 = 0: k3 = 1: k2 = 0: k1 = 0: k = ReY
              IF player$ = "1" THEN k1 = 1: square(4, 7) = 0: square(5, 7) = 11
              IF player$ = "2" THEN k2 = 1: square(4, 0) = 1: square(5, 0) = 10
              l = 5: GOSUB check
              IF player$ = "1" THEN k1 = 1: square(5, 7) = 1: square(6, 7) = 11
              IF player$ = "2" THEN k2 = 1: square(5, 0) = 0: square(6, 0) = 10
              l = 6: GOSUB check
              IF player$ = "1" THEN k1 = 1: square(6, 7) = 0: square(4, 7) = 11
              IF player$ = "2" THEN k2 = 1: square(6, 0) = 1: square(4, 0) = 10
              l = 4: GOSUB check
              IF k4 = 1 THEN buzz = true
              IF k4 = 0 THEN
                GOSUB castle
                IF buzz = false AND player$ = "1" AND ReX = 6 THEN square(7, 7) = 1: square(5, 7) = 9
                IF buzz = false AND player$ = "2" AND ReX = 6 THEN square(7, 0) = 0: square(5, 0) = 8
              END IF
            END IF
          END IF
          IF oldy = ReY AND ReX = 2 AND (square(0, ReY) = 8 OR square(0, ReY) = 9) AND square(1, ReY) < 2 AND square(3, ReY) < 2 AND square(ReX, ReY) < 2 THEN
            IF (player$ = "2" AND kingcastle1 = 0 AND rookcastle1 = 0) OR (player$ = "1" AND kingcastle2 = 0 AND rookcastle2 = 0) THEN
              k5 = 1: k4 = 0: k3 = 1: k2 = 0: k1 = 0: k = ReY
              IF player$ = "1" THEN k1 = 1: square(4, 7) = 0: square(3, 7) = 11
              IF player$ = "2" THEN k2 = 1: square(4, 0) = 1: square(3, 0) = 10
              l = 3: GOSUB check
              IF player$ = "1" THEN k1 = 1: square(3, 7) = 1: square(2, 7) = 11
              IF player$ = "2" THEN k2 = 1: square(3, 0) = 0: square(2, 0) = 10
              l = 2: GOSUB check
              IF player$ = "1" THEN k1 = 1: square(2, 7) = 0: square(4, 7) = 11
              IF player$ = "2" THEN k2 = 1: square(2, 0) = 1: square(4, 0) = 10
              l = 4: GOSUB check
              IF k4 = 1 THEN buzz = true
              IF k4 = 0 THEN
                GOSUB castle
                IF buzz = false AND player$ = "1" AND ReX = 2 THEN square(0, 7) = 0: square(3, 7) = 9
                IF buzz = false AND player$ = "2" AND ReX = 2 THEN square(0, 0) = 1: square(3, 0) = 8
              END IF
            END IF
          END IF
        CASE 12, 13: 'checks queen move legitimacy
          IF NOT (ABS(x - oldx) = ABS(y - oldy)) AND NOT (x = oldx OR y = oldy) THEN x = oldx: y = oldy: buzz = true
          IF x = oldx OR y = oldy THEN
            IF y <> oldy THEN
              FOR chk.y = oldy TO y STEP (ABS(y - oldy) / (y - oldy))
              IF square(x, chk.y) > 1 AND square(x, chk.y) <> square(oldx, oldy) AND chk.y <> y THEN y = oldy: x = oldx: buzz = true
              NEXT
            END IF
            IF x <> oldx THEN
              FOR chk.x = oldx TO x STEP (ABS(x - oldx) / (x - oldx))
              IF square(chk.x, y) > 1 AND square(chk.x, y) <> square(oldx, oldy) AND chk.x <> x THEN y = oldy: x = oldx: buzz = true
              NEXT
            END IF
          ELSE
            IF ReY <> oldy AND ReX <> oldx THEN
              chk.x = oldx: FOR chk.y = oldy TO ReY STEP (ABS(ReY - oldy) / (ReY - oldy))
              IF chk.y <> oldy THEN chk.x = chk.x + ((ABS(ReX - oldx) / (ReX - oldx)))
              IF square(chk.x, chk.y) > 1 AND square(chk.x, chk.y) <> square(oldx, oldy) AND (chk.x <> ReX AND chk.y <> ReY) THEN y = oldy: x = oldx: buzz = true
              NEXT
            END IF
          END IF
      END SELECT
        IF buzz = 1 THEN GOSUB buzz
      ELSE IF playerno = oldplayerno AND MouseB% = 2 THEN x = oldx: y = oldy: GOSUB buzz
    END IF
  END IF
WEND
RETURN

castle:
  IF castle(square(oldx, oldy) - 9) = 0 THEN
     x = ReX: y = ReY: buzz = false: castle(square(oldx, oldy) - 9) = 1
  END IF
RETURN

mov.key:
  a = oldx: b = oldy
  IF MouseB% = 1 THEN m$ = "choose" ELSE IF MouseB% = 2 THEN m$ = "place"
  IF MouseB% <> 0 THEN MouseX% = 100: MouseY% = 100
  SELECT CASE m$
    CASE "choose": oldx = x: oldy = y: a = x: b = y
      IF player$ = "1" THEN
        SELECT CASE square(a, b)
          CASE 0, 1, 3, 5, 7, 9, 11, 13
            piece = square(x, y)
            GOSUB get.name
            w1 = 1
        END SELECT
      END IF
      IF player$ = "2" THEN
        SELECT CASE square(a, b)
          CASE 0, 1, 2, 4, 6, 8, 10, 12
            piece = square(x, y)
            GOSUB get.name
            w1 = 1
        END SELECT
      END IF
    CASE "place":
      IF (x <> oldx OR y <> oldy) AND piece > 1 AND w1 = 1 THEN
        IF playerq$ = player$ THEN
          IF piece = 10 THEN kingcastle1 = kingcastle1 + 1
          IF piece = 11 THEN kingcastle2 = kingcastle2 + 1
          IF piece = 8 AND oldx = 0 THEN rookcastle1 = rookcastle1 + 1
          IF piece = 8 AND oldx = 7 THEN rookcastle11 = rookcastle11 + 1
          IF piece = 9 AND oldx = 0 THEN rookcastle2 = rookcastle2 + 1
          IF piece = 9 AND oldx = 7 THEN rookcastle22 = rookcastle22 + 1
          square(x, y) = piece: square(oldx, oldy) = start(oldx, oldy): GOSUB board.draw
          IF player$ = "1" THEN player$ = "2" ELSE player$ = "1"
          pname$ = "        "
        END IF
      END IF
    CASE "n", "N": GOTO restart
  END SELECT
  IF x < 0 THEN x = 7 ELSE IF x > 7 THEN x = 0
  IF y < 0 THEN y = 7 ELSE IF y > 7 THEN y = 0
RETURN

load.pics:
  File$ = "": GOSUB get.name
  IF square(a, b) > 1 AND start(a, b) = 1 THEN File$ = File$ + "1" ELSE IF square(a, b) > 1 AND start(a, b) = 0 THEN File$ = File$ + "0"
  CLOSE : OPEN File$ + ".tpc" FOR INPUT AS #1: INPUT #1, scn, Xmin, Xmax, Ymin, Ymax: CLOSE
  REDIM colr(1 TO (Xmax - Xmin) * (Ymax - Ymin))
  DEF SEG = VARSEG(colr(1)): BLOAD File$ + ".PIC", VARPTR(colr(1)): DEF SEG : CLOSE
  PUT (a * scl + xini, b * scl + yini), colr, PSET
RETURN

get.name:
  SELECT CASE square(a, b)
    CASE 0: File$ = "bsq"
    CASE 1: File$ = "wsq"
    CASE 2: File$ = "pawn2"
    CASE 3: File$ = "pawn1"
    CASE 4: File$ = "knight2"
    CASE 5: File$ = "knight1"
    CASE 6: File$ = "bishop2"
    CASE 7: File$ = "bishop1"
    CASE 8: File$ = "rook2"
    CASE 9: File$ = "rook1"
    CASE 10: File$ = "king2"
    CASE 11: File$ = "king1"
    CASE 12: File$ = "queen2"
    CASE 13: File$ = "queen1"
  END SELECT
  IF m$ = "choose" THEN pname$ = LEFT$(File$, LEN(File$) - 1): playerq$ = RIGHT$(File$, 1)
  WHILE LEN(pname$) < 8: pname$ = pname$ + " ": WEND
RETURN

buzz: header$ = "   You can't do that!    "
  nowwait$ = TIME$: waitnow = 0: GOSUB prt.headings
  FOR reg% = 15 TO 215 STEP 10
    Value% = reg%: freq% = reg%
    IF piece > 1 THEN GOSUB sound.out
  NEXT reg%
  buzz = false: reg% = 0: Value% = reg%: freq% = reg%
  IF piece > 1 THEN GOSUB sound.out
  w1 = 0
  pname$ = "        "
RETURN

sound.out:
  CALL WriteReg(&H20, &H7)
  CALL WriteReg(&H40, &HF)
  CALL WriteReg(&H60, &HF0)
  CALL WriteReg(&H80, &HF0)
  CALL WriteReg(&HA0, freq%)
  CALL WriteReg(&H23, &HF)
  CALL WriteReg(&H43, &H0)
  CALL WriteReg(&H63, &HF0)
  CALL WriteReg(&H83, &HFF)
  CALL WriteReg(&HB0, &H20)
  CALL WriteReg(&HE0, &H0)
RETURN

boxes:
  FOR p = 2 TO -2 STEP -1
    LINE (3 - p, 3 - p)-(98 + p, 196 + p), 25 - ABS(p * 3), B
  NEXT
  File$ = "pawn": GOSUB smallload: PUT (74, 90), colr, PSET
  File$ = "rook": GOSUB smallload: PUT (60, 91), colr, PSET
  File$ = "knight": GOSUB smallload: PUT (46, 93), colr, PSET
  File$ = "bishop": GOSUB smallload: PUT (32, 97), colr, PSET
  File$ = "queen": GOSUB smallload: PUT (18, 102), colr, PSET
  File$ = "king": GOSUB smallload: PUT (4, 111), colr, PSET
  File$ = "pawn": GOSUB smallload: PUT (75, 158), colr, PSET
  File$ = "knight": GOSUB smallload: PUT (59, 148), colr, PSET
  File$ = "bishop": GOSUB smallload: PUT (45, 139), colr, PSET
  File$ = "rook": GOSUB smallload: PUT (27, 133), colr, PSET
  File$ = "pawn": GOSUB smallload: PUT (11, 125), colr, PSET
RETURN

smallload:
  CLOSE : OPEN File$ + ".tpc" FOR INPUT AS #1: INPUT #1, scn, Xmin, Xmax, Ymin, Ymax: CLOSE
  REDIM colr(1 TO (Xmax - Xmin) * (Ymax - Ymin))
  DEF SEG = VARSEG(colr(1)): BLOAD File$ + ".PIC", VARPTR(colr(1)): DEF SEG : CLOSE
RETURN

prt.headings:
  IF nowwait$ <> TIME$ THEN waitnow = waitnow + 1
  IF waitnow >= done.waiting THEN header$ = "                         "
  IF piece > 1 THEN COLOR 11: LOCATE 2, 14 + (27 - LEN(header$)) \ 2: PRINT header$;
RETURN

board.draw:
  FOR a = 0 TO 7: FOR b = 0 TO 7: File$ = ""
  GOSUB load.pics
  NEXT: NEXT
RETURN

pal.set: PALETTE
  FOR g = 66 TO 81: PALETTE g, (((g - 66) * 3) + 10) * RED: NEXT
  FOR g = 100 TO 150: PALETTE g, (g - 100) * 65536 + (g - 100) * 256 + (g - 100): NEXT
RETURN

check:
  IF k2 = 1 THEN p = 3: h = 5: bi = 7: r = 9: q = 13
  IF k1 = 1 THEN p = 2: h = 4: bi = 6: r = 8: q = 12
  IF square(l - 1, k + 1) = p OR square(l + 1, k + 1) = p GOTO incheck
  IF square(l - 1, k + 1) = bi OR square(l + 1, k + 1) = bi GOTO incheck
  IF square(l - 1, k + 1) = q OR square(l + 1, k + 1) = q GOTO incheck
  IF square(l - 1, k - 1) = bi OR square(l + 1, k - 1) = bi GOTO incheck
  IF square(l - 1, k - 1) = q OR square(l + 1, k - 1) = q GOTO incheck
  IF square(l - 1, k) = r OR square(l + 1, k) = r GOTO incheck
  IF square(l - 1, k) = q OR square(l + 1, k) = q GOTO incheck
  IF square(l, k - 1) = r OR square(l, k + 1) = r GOTO incheck
  IF square(l, k - 1) = q OR square(l, k + 1) = q GOTO incheck
  IF square(l - 2, k + 1) = h OR square(l + 2, k + 1) = h GOTO incheck
  IF square(l - 2, k + 1) = h OR square(l + 2, k + 1) = h GOTO incheck
  IF square(l - 2, k - 1) = h OR square(l + 2, k - 1) = h GOTO incheck
  IF square(l - 2, k - 1) = h OR square(l + 2, k - 1) = h GOTO incheck
  IF square(l - 1, k - 2) = h OR square(l - 1, k + 2) = h GOTO incheck
  IF square(l - 1, k - 2) = h OR square(l - 1, k + 2) = h GOTO incheck
  IF square(l + 1, k - 2) = h OR square(l + 1, k + 2) = h GOTO incheck
  IF square(l + 1, k - 2) = h OR square(l + 1, k + 2) = h GOTO incheck
  IF square(l, k + 1) < 2 THEN
   IF square(l, k + 2) = r OR square(l, k + 2) = q GOTO incheck
   IF square(l, k + 2) < 2 THEN
    IF square(l, k + 3) = r OR square(l, k + 3) = q GOTO incheck
    IF square(l, k + 3) < 2 THEN
     IF square(l, k + 4) = r OR square(l, k + 4) = q GOTO incheck
     IF square(l, k + 4) < 2 THEN
      IF square(l, k + 5) = r OR square(l, k + 5) = q GOTO incheck
      IF square(l, k + 5) < 2 THEN
       IF square(l, k + 6) = r OR square(l, k + 6) = q GOTO incheck
       IF square(l, k + 6) < 2 THEN
        IF square(l, k + 7) = r OR square(l, k + 7) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF square(l, k - 1) < 2 THEN
   IF square(l, k - 2) = r OR square(l, k - 2) = q GOTO incheck
   IF square(l, k - 2) < 2 THEN
    IF square(l, k - 3) = r OR square(l, k - 3) = q GOTO incheck
    IF square(l, k - 3) < 2 THEN
     IF square(l, k - 4) = r OR square(l, k - 4) = q GOTO incheck
     IF square(l, k - 4) < 2 THEN
      IF square(l, k - 5) = r OR square(l, k - 5) = q GOTO incheck
      IF square(l, k - 5) < 2 THEN
       IF square(l, k - 6) = r OR square(l, k - 6) = q GOTO incheck
       IF square(l, k - 6) < 2 THEN
        IF square(l, k - 7) = r OR square(l, k - 7) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF square(l + 1, k) < 2 THEN
   IF square(l + 2, k) = r OR square(l + 2, k) = q GOTO incheck
   IF square(l + 2, k) < 2 THEN
    IF square(l + 3, k) = r OR square(l + 3, k) = q GOTO incheck
    IF square(l + 3, k) < 2 THEN
     IF square(l + 4, k) = r OR square(l + 4, k) = q GOTO incheck
     IF square(l + 4, k) < 2 THEN
      IF square(l + 5, k) = r OR square(l + 5, k) = q GOTO incheck
      IF square(l + 5, k) < 2 THEN
       IF square(l + 6, k) = r OR square(l + 6, k) = q GOTO incheck
       IF square(l + 6, k) < 2 THEN
        IF square(l + 7, k) = r OR square(l + 7, k) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF square(l - 1, k) < 2 THEN
   IF square(l - 2, k) = r OR square(l - 2, k) = q GOTO incheck
   IF square(l - 2, k) < 2 THEN
    IF square(l - 3, k) = r OR square(l - 3, k) = q GOTO incheck
    IF square(l - 3, k) < 2 THEN
     IF square(l - 4, k) = r OR square(l - 4, k) = q GOTO incheck
     IF square(l - 4, k) < 2 THEN
      IF square(l - 5, k) = r OR square(l - 5, k) = q GOTO incheck
      IF square(l - 5, k) < 2 THEN
       IF square(l - 6, k) = r OR square(l - 6, k) = q GOTO incheck
       IF square(l - 6, k) < 2 THEN
        IF square(l - 7, k) = r OR square(l - 7, k) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF square(l + 1, k + 1) < 2 THEN
   IF square(l + 2, k + 2) = bi OR square(l + 2, k + 2) = q GOTO incheck
   IF square(l + 2, k + 2) < 2 THEN
    IF square(l + 3, k + 3) = bi OR square(l + 3, k + 3) = q GOTO incheck
    IF square(l + 3, k + 3) < 2 THEN
     IF square(l + 4, k + 4) = bi OR square(l + 4, k + 4) = q GOTO incheck
     IF square(l + 4, k + 4) < 2 THEN
      IF square(l + 5, k + 5) = bi OR square(l + 5, k + 5) = q GOTO incheck
      IF square(l + 5, k + 5) < 2 THEN
       IF square(l + 6, k + 6) = bi OR square(l + 6, k + 6) = q GOTO incheck
       IF square(l + 6, k + 6) < 2 THEN
        IF square(l + 7, k + 7) = bi OR square(l + 7, k + 7) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF square(l - 1, k - 1) < 2 THEN
   IF square(l - 2, k - 2) = bi OR square(l - 2, k - 2) = q GOTO incheck
   IF square(l - 2, k - 2) < 2 THEN
    IF square(l - 3, k - 3) = bi OR square(l - 3, k - 3) = q GOTO incheck
    IF square(l - 3, k - 3) < 2 THEN
     IF square(l - 4, k - 4) = bi OR square(l - 4, k - 4) = q GOTO incheck
     IF square(l - 4, k - 4) < 2 THEN
      IF square(l - 5, k - 5) = bi OR square(l - 5, k - 5) = q GOTO incheck
      IF square(l - 5, k - 5) < 2 THEN
       IF square(l - 6, k - 6) = bi OR square(l - 6, k - 6) = q GOTO incheck
       IF square(l - 6, k - 6) < 2 THEN
        IF square(l - 7, k - 7) = bi OR square(l - 7, k - 7) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF square(l - 1, k + 1) < 2 THEN
   IF square(l - 2, k + 2) = bi OR square(l - 2, k + 2) = q GOTO incheck
   IF square(l - 2, k + 2) < 2 THEN
    IF square(l - 3, k + 3) = bi OR square(l - 3, k + 3) = q GOTO incheck
    IF square(l - 3, k + 3) < 2 THEN
     IF square(l - 4, k + 4) = bi OR square(l - 4, k + 4) = q GOTO incheck
     IF square(l - 4, k + 4) < 2 THEN
      IF square(l - 5, k + 5) = bi OR square(l - 5, k + 5) = q GOTO incheck
      IF square(l - 5, k + 5) < 2 THEN
       IF square(l - 6, k + 6) = bi OR square(l - 6, k + 6) = q GOTO incheck
       IF square(l - 6, k + 6) < 2 THEN
        IF square(l - 7, k + 7) = bi OR square(l - 7, k + 7) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF square(l + 1, k - 1) < 2 THEN
   IF square(l + 2, k - 2) = bi OR square(l + 2, k - 2) = q GOTO incheck
   IF square(l + 2, k - 2) < 2 THEN
    IF square(l + 3, k - 3) = bi OR square(l + 3, k - 3) = q GOTO incheck
    IF square(l + 3, k - 3) < 2 THEN
     IF square(l + 4, k - 4) = bi OR square(l + 4, k - 4) = q GOTO incheck
     IF square(l + 4, k - 4) < 2 THEN
      IF square(l + 5, k - 5) = bi OR square(l + 5, k - 5) = q GOTO incheck
      IF square(l + 5, k - 5) < 2 THEN
       IF square(l + 6, k - 6) = bi OR square(l + 6, k - 6) = q GOTO incheck
       IF square(l + 6, k - 6) < 2 THEN
        IF square(l + 7, k - 7) = bi OR square(l + 7, k - 7) = q GOTO incheck
       END IF
      END IF
     END IF
    END IF
   END IF
  END IF
  IF k3 = 0 THEN LOCATE 24, 5: PRINT "     "; : k$ = ""
RETURN

incheck:
  IF k5 = 1 THEN k4 = 1: RETURN
  IF k3 = 1 THEN
    IF player$ = "1" THEN player$ = "2" ELSE player$ = "1"
    square(x, y) = sq: square(oldx, oldy) = oldsq
    IF k$ <> "" THEN k6 = 1
    LOCATE 24, 5: PRINT "     "; : k$ = ""
    buzz = true: GOSUB buzz
  END IF
  IF k3 <> 1 AND k$ = "" THEN COLOR 64: LOCATE 24, 5: PRINT "Check"; : GOSUB checkbuzz: IF player$ = "1" THEN k$ = "1" ELSE k$ = "2"
RETURN

checkbuzz:
 FOR r = 1 TO 3
  FOR reg% = 255 TO 155 STEP -40
    Value% = reg%: freq% = reg%
    IF piece > 1 THEN GOSUB sound.out
  NEXT reg%
 NEXT
  FOR reg% = 255 TO 55 STEP -35
    Value% = reg%: freq% = reg%
    IF piece > 1 THEN GOSUB sound.out
  NEXT reg%
  reg% = 0: Value% = reg%: freq% = reg%
  IF piece > 1 THEN GOSUB sound.out
RETURN

SUB LoadConfiguration
  SHARED mouse%()
  RESTORE DATA.Mouse
  DEF SEG = VARSEG(mouse%(0))
  FOR I% = 0 TO 52
    READ Byte$
    POKE VARPTR(mouse%(0)) + I%, VAL("&H" + Byte$)
  NEXT
  MouseArea 1, 319, 1, 199
  MouseSpeed 30
  MouseSet 200, 100
  MousePointer "On"
END SUB

SUB MouseArea (x1%, x2%, y1%, y2%)
  r% = MouseInterr%(&H33, 7, 0, x1%, x2%)
  r% = MouseInterr%(&H33, 8, bx%, y1%, y2%)
END SUB

SUB MouseDriver (ax%, bx%, cx%, dx%)
  DEF SEG = VARSEG(mouse$)
  mouse% = SADD(mouse$)
  CALL ABSOLUTE(ax%, bx%, cx%, dx%, mouse%)
END SUB

SUB MouseHide
  ax% = 2
  MouseDriver ax%, 0, 0, 0
END SUB

FUNCTION MouseInit%
  ax% = 0
  MouseDriver ax%, 0, 0, 0
  MouseInit% = ax%
END FUNCTION

FUNCTION MouseInterr% (num%, ax%, bx%, cx%, dx%)
  SHARED mouse%()
  IF mouse%(0) = 0 THEN
    PRINT "Mouse error, program stopped"
    SYSTEM
  END IF
  DEF SEG = VARSEG(mouse%(0))
  POKE VARPTR(mouse%(0)) + 26, num%
  CALL ABSOLUTE(ax%, bx%, cx%, dx%, VARPTR(mouse%(0)))
  MouseInterr% = ax%
END FUNCTION

SUB MousePointer (OnOrOff$)
  SELECT CASE OnOrOff$
    CASE "On": r% = MouseInterr%(&H33, 1, bx%, cx%, dx%)
    CASE "Off": r% = MouseInterr%(&H33, 2, bx%, cx%, dx%)
  END SELECT
END SUB

SUB MousePut
  ax% = 4
  cx% = x%
  dx% = y%
  MouseDriver ax%, 0, cx%, dx%
END SUB

SUB MouseSet (x%, y%)
  r% = MouseInterr%(&H33, 4, bx%, x%, y%)
END SUB

SUB mouseshow
  ax% = 1
  MouseDriver ax%, 0, 0, 0
END SUB

SUB MouseSpeed (Speed%)
  'Speed 0 = extremly fast, Speed 100 = extremly slow
  r% = MouseInterr%(&H33, 15, bx%, Speed%, Speed% * 2)
END SUB

SUB mousestatus (lb%, RB%, Xmouse%, Ymouse%)
  ax% = 3
  MouseDriver ax%, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  RB% = ((bx% AND 2) <> 0)
  Xmouse% = cx%
  Ymouse% = dx%
END SUB

SUB MouseWait
  SHARED MouseX%, MouseY%, MouseB%, m$, k$, PL$
  OldMX% = MouseX%
  OldMY% = MouseY%
  OldMB% = MouseB%
  WHILE (OldMX% = MouseX% AND OldMY% = MouseY% AND OldMB% = MouseB%) AND m$ = ""
    m$ = LCASE$(INKEY$)
    IF m$ = CHR$(27) GOTO playagain2
    r% = MouseInterr%(&H33, 3, MouseB%, MouseX%, MouseY%)
    a = oldx: b = oldy: GOSUB load.pics2
    a = x: b = y: GOSUB load.pics2
    GOSUB prt.headings.2
  WEND
GOTO end.sub.mw

load.pics2:
  File$ = "": GOSUB get.name2
  IF square(a, b) > 1 AND start(a, b) = 1 THEN File$ = File$ + "1" ELSE IF square(a, b) > 1 AND start(a, b) = 0 THEN File$ = File$ + "0"
  CLOSE : OPEN File$ + ".tpc" FOR INPUT AS #1: INPUT #1, scn, Xmin, Xmax, Ymin, Ymax: CLOSE
  REDIM colr(1 TO (Xmax - Xmin) * (Ymax - Ymin))
  DEF SEG = VARSEG(colr(1)): BLOAD File$ + ".PIC", VARPTR(colr(1)): DEF SEG : CLOSE
  PUT (a * scl + xini, b * scl + yini), colr, PSET
RETURN

get.name2:
  SELECT CASE square(a, b)
    CASE 0: File$ = "bsq"
    CASE 1: File$ = "wsq"
    CASE 2: File$ = "pawn2"
    CASE 3: File$ = "pawn1"
    CASE 4: File$ = "knight2"
    CASE 5: File$ = "knight1"
    CASE 6: File$ = "bishop2"
    CASE 7: File$ = "bishop1"
    CASE 8: File$ = "rook2"
    CASE 9: File$ = "rook1"
    CASE 10: File$ = "king2"
    CASE 11: File$ = "king1"
    CASE 12: File$ = "queen2"
    CASE 13: File$ = "queen1"
  END SELECT
  WHILE LEN(pname$) < 8: pname$ = pname$ + " ": WEND
RETURN

prt.headings.2:
  IF nowwait$ <> TIME$ THEN waitnow = waitnow + 1
  IF waitnow >= done.waiting THEN header$ = "                         "
  IF piece > 1 THEN COLOR 14: LOCATE 2, 14 + (27 - LEN(header$)) \ 2: PRINT header$;
RETURN

playagain2:
  IF k$ = "2" THEN LOCATE 2, 15: COLOR 7: PRINT "Check Mate - Player 1 Wins"
  IF k$ = "1" THEN LOCATE 2, 15: COLOR 4: PRINT "Check Mate - Player 2 Wins"
  LOCATE 24, 18: PRINT "PLAY AGAIN Y / N ?  "; : PL$ = INPUT$(1)
  IF PL$ = "Y" OR PL$ = "y" OR PL$ = "N" OR PL$ = "n" GOTO yesno2 ELSE GOTO playagain2
yesno2:
end.sub.mw:
END SUB

DEFINT A-Z
SUB Viewgif (File$, MyOffX, MyOffY, Transparent)

DIM Prefix(4095), Suffix(4095), OutStack(4095), shiftout%(8)
DIM Ybase AS LONG, powersof2(11) AS LONG, WorkCode AS LONG
    
OPEN File$ + ".GIF" FOR INPUT AS #1
CLOSE #1
FOR a% = 0 TO 7: shiftout%(8 - a%) = 2 ^ a%: NEXT a%
FOR a% = 0 TO 11: powersof2(a%) = 2 ^ a%: NEXT a%
a$ = File$
IF a$ = "" THEN INPUT "GIF file"; a$: IF a$ = "" THEN END
IF INSTR(a$, ".") = 0 THEN a$ = a$ + ".gif"
OPEN a$ FOR BINARY AS #1
a$ = "      ": GET #1, , a$
'IF a$ <> "GIF87a" THEN PRINT "Not a GIF87a file.": END
GET #1, , TotalX: GET #1, , TotalY: GOSUB GetByte
NumColors = 2 ^ ((a% AND 7) + 1): NoPalette = (a% AND 128) = 0
GOSUB GetByte: Background = a%
GOSUB GetByte: IF a% <> 0 THEN PRINT "Bad screen descriptor.": END
IF NoPalette = 0 THEN p$ = SPACE$(NumColors * 3): GET #1, , p$
DO
    GOSUB GetByte
    IF a% = 44 THEN
        EXIT DO
    ELSEIF a% <> 33 THEN
        PRINT "Unknown extension type.": END
    END IF
    GOSUB GetByte
    DO: GOSUB GetByte: a$ = SPACE$(a%): GET #1, , a$: LOOP UNTIL a% = 0
LOOP
GET #1, , XStart: GET #1, , YStart: GET #1, , XLength: GET #1, , YLength
XEnd = XStart + XLength: YEnd = YStart + YLength: GOSUB GetByte
IF a% AND 128 THEN PRINT "Can't handle local colormaps.": END
Interlaced = a% AND 64: PassNumber = 0: PassStep = 8
GOSUB GetByte
ClearCode = 2 ^ a%
EOSCode = ClearCode + 1
FirstCode = ClearCode + 2: NextCode = FirstCode
StartCodeSize = a% + 1: CodeSize = StartCodeSize
StartMaxCode = 2 ^ (a% + 1) - 1: MaxCode = StartMaxCode

BitsIn = 0: BlockSize = 0: BlockPointer = 1
x% = XStart: y% = YStart: Ybase = y% * 320&

SCREEN 13: DEF SEG = &HA000
IF NoPalette = 0 THEN
    OUT &H3C7, 0: OUT &H3C8, 0
    FOR a% = 1 TO NumColors * 3: OUT &H3C9, ASC(MID$(p$, a%, 1)) \ 4: NEXT a%
END IF
'LINE (0, 0)-(319, 199), Background, BF
DO
  GOSUB GetCode
  IF Code <> EOSCode THEN
    IF Code = ClearCode THEN
      NextCode = FirstCode
      CodeSize = StartCodeSize
      MaxCode = StartMaxCode
      GOSUB GetCode
      CurCode = Code: LastCode = Code: LastPixel = Code
      IF x% + MyOffX < 320 AND LastPixel <> Transparent THEN POKE x% + MyOffX + Ybase, LastPixel
      x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLine
    ELSE
      CurCode = Code: StackPointer = 0
      IF Code > NextCode THEN EXIT DO
      IF Code = NextCode THEN
        CurCode = LastCode
        OutStack(StackPointer) = LastPixel
        StackPointer = StackPointer + 1
      END IF

      DO WHILE CurCode >= FirstCode
        OutStack(StackPointer) = Suffix(CurCode)
        StackPointer = StackPointer + 1
        CurCode = Prefix(CurCode)
      LOOP

      LastPixel = CurCode
      IF x% + MyOffX < 320 AND LastPixel <> Transparent THEN POKE x% + MyOffX + Ybase, LastPixel
      x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLine

      FOR a% = StackPointer - 1 TO 0 STEP -1
        IF x% + MyOffX < 320 AND OutStack(a%) <> Transparent THEN POKE x% + MyOffX + Ybase, OutStack(a%)
        x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLine
      NEXT a%

      IF NextCode < 4096 THEN
        Prefix(NextCode) = LastCode
        Suffix(NextCode) = LastPixel
        NextCode = NextCode + 1
        IF NextCode > MaxCode AND CodeSize < 12 THEN
          CodeSize = CodeSize + 1
          MaxCode = MaxCode * 2 + 1
        END IF
      END IF
      LastCode = Code
    END IF
  END IF
LOOP UNTIL DoneFlag OR Code = EOSCode
CLOSE #1
EXIT SUB

GetByte: a$ = " ": GET #1, , a$: a% = ASC(a$): RETURN

NextScanLine:
  IF Interlaced THEN
    y% = y% + PassStep
    IF y% >= YEnd THEN
      PassNumber = PassNumber + 1
      SELECT CASE PassNumber
        CASE 1: y% = 4: PassStep = 8
        CASE 2: y% = 2: PassStep = 4
        CASE 3: y% = 1: PassStep = 2
      END SELECT
    END IF
  ELSE
    y% = y% + 1
  END IF
  x% = XStart: Ybase = (y% + MyOffY) * 320&: DoneFlag = y% > 199
RETURN
GetCode:
  IF BitsIn = 0 THEN GOSUB ReadBufferedByte: LastChar = a%: BitsIn = 8
  WorkCode = LastChar \ shiftout%(BitsIn)
  DO WHILE CodeSize > BitsIn
    GOSUB ReadBufferedByte: LastChar = a%
    WorkCode = WorkCode OR LastChar * powersof2(BitsIn)
    BitsIn = BitsIn + 8
  LOOP
  BitsIn = BitsIn - CodeSize
  Code = WorkCode AND MaxCode
RETURN
ReadBufferedByte:
  IF BlockPointer > BlockSize THEN
    GOSUB GetByte: BlockSize = a%
    a$ = SPACE$(BlockSize): GET #1, , a$
    BlockPointer = 1
  END IF
  a% = ASC(MID$(a$, BlockPointer, 1)): BlockPointer = BlockPointer + 1
RETURN

END SUB

DEFSNG A-Z
SUB WriteReg (reg%, Value%)
  OUT &H388, reg%
  FOR gox = 0 TO 5
    a = INP(&H388)
  NEXT gox
  OUT &H389, Value%
  FOR gox = 0 TO 34
    a = INP(&H388)
  NEXT gox
END SUB

